package cz.jzitnik.chronos.interactions.list;

import cz.jzitnik.chronos.entities.Character;
import cz.jzitnik.chronos.entities.Item;
import cz.jzitnik.chronos.entities.ItemType;
import cz.jzitnik.chronos.entities.Player;
import cz.jzitnik.chronos.interactions.InteractionPlayer;
import cz.jzitnik.chronos.payload.responses.InteractionResponse;
import cz.jzitnik.chronos.repository.CharacterRepository;
import cz.jzitnik.chronos.repository.ItemRepository;
import cz.jzitnik.chronos.services.ItemService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;

@Service
public class Baker implements InteractionPlayer {
    @Autowired
    private ItemService itemService;
    @Autowired
    private CharacterRepository characterRepository;
    @Autowired
    private ItemRepository itemRepository;

    @Override
    public InteractionResponse play(Player player, Character character, String data) {
        var playerItems = player.getInventory();
        var flours = playerItems.stream().filter(item -> item.getItemType().equals(ItemType.FLOUR)).toList();
        var water = playerItems.stream().filter(item -> item.getItemType().equals(ItemType.WATER)).toList();

        if (flours.isEmpty() || water.isEmpty()) {
            return new InteractionResponse(false, "Nemáš pro mě buď mouku nebo vodu. Dej mi obojí najednou!", new ArrayList<>());
        }

        var flour = flours.get(0);
        flour.setOwner(null);
        itemRepository.save(flour);
        playerItems.remove(flour);

        var onewater = water.get(0);
        onewater.setOwner(null);
        itemRepository.save(onewater);
        playerItems.remove(onewater);

        var item = new Item(ItemType.KEY_FRAGMENT, player);
        itemService.addItem(player, item);

        character.setInteractedWith(true);
        characterRepository.save(character);

        var items = new ArrayList<Item>();
        items.add(item);

        return new InteractionResponse(false, "Díky moc za mouku a vodu. Doplnit dialog!!!", items);
    }
}
