package cz.jzitnik.chronos.interactions.list;

import cz.jzitnik.chronos.entities.Character;
import cz.jzitnik.chronos.entities.Item;
import cz.jzitnik.chronos.entities.ItemType;
import cz.jzitnik.chronos.entities.Player;
import cz.jzitnik.chronos.interactions.InteractionPlayer;
import cz.jzitnik.chronos.payload.responses.InteractionResponse;
import cz.jzitnik.chronos.repository.CharacterRepository;
import cz.jzitnik.chronos.repository.ItemRepository;
import cz.jzitnik.chronos.services.ItemService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;

@Service
public class Mayor implements InteractionPlayer {
    @Autowired
    private ItemService itemService;
    @Autowired
    private CharacterRepository characterRepository;
    @Autowired
    private ItemRepository itemRepository;

    @Override
    public InteractionResponse play(Player player, Character character, String data) {
        var playerItems = player.getInventory();
        var goldenWatches = playerItems.stream().filter(item -> item.getItemType().equals(ItemType.GOLDEN_WATCH)).toList();

        if (goldenWatches.isEmpty()) {
            return new InteractionResponse(false, "Nemáš zlaté hodinky v inventáři!", new ArrayList<>());
        }

        var goldenWatch = goldenWatches.get(0);
        goldenWatch.setOwner(null);
        itemRepository.save(goldenWatch);
        playerItems.remove(goldenWatch);

        var item = new Item(ItemType.KEY_FRAGMENT, player);
        itemService.addItem(player, item);

        character.setInteractedWith(true);
        characterRepository.save(character);

        var items = new ArrayList<Item>();
        items.add(item);

        return new InteractionResponse(false, "Díky moc za mé ztracené zlaté hodinky... Doplnit dialog!!!", items);
    }
}
